using Microsoft.EntityFrameworkCore;
using Swashbuckle.AspNetCore.SwaggerGen;

namespace HackathonPreparing.ApiService.Features.DevFeature;

public static class ReflectionHelpers
{
    private static IEnumerable<Type>? EfCoreDbContexts;

    // !!!!
    // DONT USE FOR HIGH CONCURANCY TASKS
    // IT NOT FOR MULTITHREADING CODE
    // OF FOR MANY REQUESTS PER MINUTE
    // !!!!

    public static IEnumerable<Type> GetEfCoreClassContexts()
    {
        
        if(EfCoreDbContexts is null)
        {
            //Get all types with DbContext parent type
            EfCoreDbContexts = typeof(Program).Assembly.GetTypes().Where(t => 
                t.GetInheritanceChain().Any(inheritanType => 
                    !string.IsNullOrEmpty(inheritanType.Name) && inheritanType.Name == nameof(DbContext)));
        }
        return EfCoreDbContexts;
    }
}